Package com.sas.metadata.remote

# Interface TransformationStep

All Superinterfaces:
  `AbstractTransformation`, `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

All Known Subinterfaces:
  `SyncStep`

public interface TransformationStep extends AbstractTransformation
TransformationStep contains mapping objects. They may be ordered using an association to StepPrecedence.

Attributes of TransformationStep are:

Associations of TransformationStep are:

- `PredecessorDependencies`
- `SuccessorDependencies`
- `Transformations`
- `Activities`

## Usage

To create an instance of this TransformationStep, use the `factory` create methods.
Example: create a TransformationStep with name "TransformationStep_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     TransformationStep myObject = (TransformationStep) factory.createComplexMetadataObject(objectStore, "TransformationStep_Object", MetadataObjects.TRANSFORMATIONSTEP, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_ACTIVITIES_NAME`
  Constant used for the name of the Activities association.
  `static final String`
  `ASSOCIATION_PREDECESSORDEPENDENCIES_NAME`
  Constant used for the name of the PredecessorDependencies association.
  `static final String`
  `ASSOCIATION_SUCCESSORDEPENDENCIES_NAME`
  Constant used for the name of the SuccessorDependencies association.
  `static final String`
  `ASSOCIATION_TRANSFORMATIONS_NAME`
  Constant used for the name of the Transformations association.

  ### Fields inherited from interface com.sas.metadata.remote.AbstractTransformation

  `ASSOCIATION_COMPUTELOCATIONS_NAME, ASSOCIATION_CONDITIONACTIONSETS_NAME, ASSOCIATION_CUSTOMIZERS_NAME, ASSOCIATION_DEPLOYEDCOMPONENTS_NAME, ASSOCIATION_SOURCECODE_NAME, ASSOCIATION_SOURCESPECIFICATIONS_NAME, ASSOCIATION_SUBSTITUTIONVARIABLES_NAME, ASSOCIATION_TARGETSPECIFICATIONS_NAME, ASSOCIATION_TRANSFORMATIONSOURCES_NAME, ASSOCIATION_TRANSFORMATIONTARGETS_NAME, ASSOCIATION_TRIGGEREDEVENTS_NAME, ASSOCIATION_TRIGGERINGEVENTS_NAME, ATTRIBUTE_ISACTIVE_NAME, ATTRIBUTE_ISUSERDEFINED_NAME, ATTRIBUTE_TRANSFORMROLE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AssociationList`
  `getActivities()`
  Gets the Association list of `Activities`
  `AssociationList`
  `getActivities(boolean fGoToServer)`
  Gets the Associationlist of `Activities`
  `AssociationList`
  `getPredecessorDependencies()`
  Gets the AssociationList of `PredecessorDependencies`
  `AssociationList`
  `getPredecessorDependencies(boolean fGoToServer)`
  Gets the Associationlist of `PredecessorDependencies`
  `AssociationList`
  `getSuccessorDependencies()`
  Gets the AssociationList of `SuccessorDependencies`
  `AssociationList`
  `getSuccessorDependencies(boolean fGoToServer)`
  Gets the Associationlist of `SuccessorDependencies`
  `AssociationList`
  `getTransformations()`
  Gets the AssociationList of `Transformations`
  `AssociationList`
  `getTransformations(boolean fGoToServer)`
  Gets the Associationlist of `Transformations`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `PredecessorDependencies`
  `SuccessorDependencies`
  `Transformations`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setActivities(AssociationList list)`
  Sets the `Activities` list to be `list`.
  `void`
  `setActivities(AssociationList inObjects, int state)`
  Sets the entire Activities list to match the passed in AssociationList, sets the state of the Activities
  `void`
  `setPredecessorDependencies(AssociationList list)`
  Sets the `PredecessorDependencies` list to be `list`.
  `void`
  `setPredecessorDependencies(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setSuccessorDependencies(AssociationList list)`
  Sets the `SuccessorDependencies` list to be `list`.
  `void`
  `setSuccessorDependencies(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setTransformations(AssociationList list)`
  Sets the `Transformations` list to be `list`.
  `void`
  `setTransformations(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList

  ### Methods inherited from interface com.sas.metadata.remote.AbstractTransformation

  `getComputeLocations, getComputeLocations, getConditionActionSets, getConditionActionSets, getCustomizers, getCustomizers, getDeployedComponents, getDeployedComponents, getIsActive, getIsActiveState, getIsUserDefined, getIsUserDefinedState, getSourceCode, getSourceCodes, getSourceCodes, getSourceSpecifications, getSourceSpecifications, getSubstitutionVariables, getSubstitutionVariables, getTargetSpecifications, getTargetSpecifications, getTransformationSources, getTransformationSources, getTransformationTargets, getTransformationTargets, getTransformRole, getTransformRoleMaxLength, getTransformRoleState, getTriggeredEvents, getTriggeredEvents, getTriggeringEvents, getTriggeringEvents, setComputeLocations, setComputeLocations, setConditionActionSets, setConditionActionSets, setCustomizers, setCustomizers, setDeployedComponents, setDeployedComponents, setIsActive, setIsActive, setIsActive, setIsActive, setIsActiveState, setIsUserDefined, setIsUserDefined, setIsUserDefined, setIsUserDefined, setIsUserDefinedState, setSourceCode, setSourceCodes, setSourceCodes, setSourceSpecifications, setSourceSpecifications, setSubstitutionVariables, setSubstitutionVariables, setTargetSpecifications, setTargetSpecifications, setTransformationSources, setTransformationSources, setTransformationTargets, setTransformationTargets, setTransformRole, setTransformRole, setTransformRoleState, setTriggeredEvents, setTriggeredEvents, setTriggeringEvents, setTriggeringEvents`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ASSOCIATION_PREDECESSORDEPENDENCIES_NAME

    static final String ASSOCIATION_PREDECESSORDEPENDENCIES_NAME
    Constant used for the name of the PredecessorDependencies association.

    PredecessorDependencies: List of StepPrecedences where this TransformationStep acts as a predecessor to another TransformationStep.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_SUCCESSORDEPENDENCIES_NAME

    static final String ASSOCIATION_SUCCESSORDEPENDENCIES_NAME
    Constant used for the name of the SuccessorDependencies association.

    SuccessorDependencies: List of StepPrecedences where this TransformationStep acts as a successor to another TransformationStep.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_TRANSFORMATIONS_NAME

    static final String ASSOCIATION_TRANSFORMATIONS_NAME
    Constant used for the name of the Transformations association.

    Transformations: The list of transformations associated with these steps.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_ACTIVITIES_NAME

    static final String ASSOCIATION_ACTIVITIES_NAME
    Constant used for the name of the Activities association.

    Activities: The list of activities that include this step.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `AbstractTransformation`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `PredecessorDependencies`
    `SuccessorDependencies`
    `Transformations`
    Specified by:
      `initializePredObjects` in interface `AbstractTransformation`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPredecessorDependencies

    AssociationList getPredecessorDependencies() throws RemoteException, MdException
    Gets the AssociationList of `PredecessorDependencies`
    Returns:
      Returns the AssociationList of `PredecessorDependencies` which can be of type:
      StepPrecedence
      ConditionalPrecedence
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSuccessorDependencies

    AssociationList getSuccessorDependencies() throws RemoteException, MdException
    Gets the AssociationList of `SuccessorDependencies`
    Returns:
      Returns the AssociationList of `SuccessorDependencies` which can be of type:
      StepPrecedence
      ConditionalPrecedence
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTransformations

    AssociationList getTransformations() throws RemoteException, MdException
    Gets the AssociationList of `Transformations`
    Returns:
      Returns the AssociationList of `Transformations` which can be of type:
      Transformation
      ClassifierMap
      Select
      Join
      AbstractJob
      Job
      JFJob
      MiningResult
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getActivities

    AssociationList getActivities() throws RemoteException, MdException
    Gets the Association list of `Activities`
    Returns:
      The AssociationList of `Activities` which can be of type:
      TransformationActivity
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPredecessorDependencies

    AssociationList getPredecessorDependencies(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `PredecessorDependencies`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `PredecessorDependencies` which can be of type:
      StepPrecedence
      ConditionalPrecedence
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSuccessorDependencies

    AssociationList getSuccessorDependencies(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `SuccessorDependencies`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `SuccessorDependencies` which can be of type:
      StepPrecedence
      ConditionalPrecedence
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getTransformations

    AssociationList getTransformations(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Transformations`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Transformations` which can be of type:
      Transformation
      ClassifierMap
      Select
      Join
      AbstractJob
      Job
      JFJob
      MiningResult
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getActivities

    AssociationList getActivities(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Activities`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Activities` which can be of type:
      TransformationActivity
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setPredecessorDependencies

    void setPredecessorDependencies(AssociationList list) throws RemoteException
    Sets the `PredecessorDependencies` list to be `list`. Objects of which can be of type:
    StepPrecedence
    ConditionalPrecedence
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPredecessorDependencies

    void setPredecessorDependencies(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSuccessorDependencies

    void setSuccessorDependencies(AssociationList list) throws RemoteException
    Sets the `SuccessorDependencies` list to be `list`. Objects of which can be of type:
    StepPrecedence
    ConditionalPrecedence
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSuccessorDependencies

    void setSuccessorDependencies(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTransformations

    void setTransformations(AssociationList list) throws RemoteException
    Sets the `Transformations` list to be `list`. Objects of which can be of type:
    Transformation
    ClassifierMap
    Select
    Join
    AbstractJob
    Job
    JFJob
    MiningResult
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTransformations

    void setTransformations(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setActivities

    void setActivities(AssociationList list) throws RemoteException
    Sets the `Activities` list to be `list`. Objects of which can be of type:
    TransformationActivity
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setActivities

    void setActivities(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Activities list to match the passed in AssociationList, sets the state of the Activities
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.